import assign from 'object-assign';
import React, { PropTypes } from 'react';
import Component from 'react-class'

const emptyFn = () => {};

import './index.scss'

export default class Icon extends Component {

  render(){
    var props = this.props;

    //prepare style
    var sizeStyle = {};

    if (props.size){
      sizeStyle.fontSize = props.size;
    }
    if (props.color){
      sizeStyle.color = props.color;
    }

    var style = assign({}, sizeStyle, props.style);

    //prepare className
    var className = 'materialIcons material-icons ' + (props.className || '');
    if (props.disabled) {
      className += ' disabled';
    }

    const iProps = assign({}, props)

    delete iProps.name
    delete iProps.dark

    return <i {...iProps} style={style} className={className} onClick={props.disabled? emptyFn: props.onClick}>
      {props.name || props.children}
    </i>;
  }
}

Icon.defaultProps = {
  dark: true
};

Icon.propTypes = {
  size: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  type: PropTypes.string,
  color: PropTypes.string,
  disabled: PropTypes.bool
};
