import { render } from 'react-dom'
import React from 'react'
import Component from 'react-class'
// import faker from 'faker'
import List from './src'
// import throttle from 'lodash.throttle'
import ScrollContainer from './src'
import './style/index.scss'
import Example from './example'

const countries = [
  'USA',
  'UK',
  'Romania',
  'Spain',
  'Italy',
  'France',
  'Germany',
  'Brazil',
  'Portugal',
  'Denmark',
  'Sweden'
]

const cache = {}

class App extends Component {

  constructor(props) {
    super(props)
    this.state = {
      counter: 0,
      stopped: false,
      from: 0,
      tempScrollTop: 0,
      scrollTop: 0,
      sendCounter: true
    }

    // this.setScrollTop = throttle(this.setScrollTop, 1500, { leading: false })

    this.listStyle = {
        border: '1px solid magenta',
        margin: 20,
        height: '50vh'
      }
  }

  renderRow({ index }) {
    if (cache[index]) {
      return cache[index]
    }
    const name = faker.name.lastName()
    const space = (index % 4) * Math.floor(Math.random() * 20)

    return cache[index] = <div key={index} style={{ paddingTop: space, paddingBottom: space, borderTop: index ? '1px solid blue' : 0 }}>
      <div style={{display: 'inline-block', border: '1px solid red', padding: 10 }}>
        {name[0]} - {index}
        <input />
      </div>
      <div style={{padding: 10, display: 'inline-block', verticalAlign: 'middle'}}>
        <div>{name}</div>
        <div>Country: {countries[index % countries.length]}</div>
      </div>
    </div>
  }

  plusOne() {
    this.setState({
      counter: this.state.counter + 1
    })
  }

  toggleSendCounter() {
    this.setState({
      sendCounter: !this.state.sendCounter
    })
  }

  onChangeScrollTop(e) {
    this.setState({
      tempScrollTop: e.target.value * 1 || 0
    })
  }

  go() {
    this.setState({
      scrollTop: this.state.tempScrollTop
    })
  }

  setScrollTop(scrollTop) {
    this.setState({
      scrollTop
    })
  }

  render() {
    return <Example />
  }
  xrender() {
    return <div style={{padding: 50}}>

    ------------
    <ScrollContainer scrollThumbWidth={5} style={{maxHeight: '50vh', maxWidth: '50vh', border: '1px solid black' }} autoHide={false} scrollThumbMargin={5}>

    <div style={{minWidth: '100vh', border: '1px solid red', padding: 20}}>
      Reprehenderit amet ut laboris do duis Lorem et nulla sunt voluptate. Eiusmod commodo aliquip exercitation magna do. Enim voluptate dolor consequat minim incididunt qui culpa.
      Occaecat aute tempor nostrud non. Commodo reprehenderit occaecat nulla exercitation aute aute eiusmod deserunt eiusmod adipisicing in. Deserunt esse eu nostrud occaecat ea elit deserunt nostrud. Cupidatat reprehenderit velit pariatur ad qui enim aliquip ipsum ut ex aliquip pariatur. Aute amet nulla ipsum consectetur pariatur ad elit ea qui labore. Laboris officia ullamco exercitation eu reprehenderit nisi laborum cillum in fugiat mollit duis nostrud nostrud.Et culpa magna amet labore exercitation ea minim. Quis cupidatat in in dolore. Reprehenderit mollit deserunt occaecat in eu ad veniam enim officia consequat aliquip reprehenderit eu.
      Ipsum ipsum sunt anim in irure est ullamco nisi. Velit cupidatat voluptate pariatur commodo exercitation deserunt aliqua nostrud sunt. Lorem veniam dolor et consequat deserunt anim ullamco consequat qui dolor ex et officia sunt. Aute laborum officia ut aliqua sint duis pariatur fugiat incididunt. Elit qui esse pariatur eu ipsum. Et sit voluptate ullamco veniam. Aute cupidatat tempor ad in dolore reprehenderit mollit nulla exercitation ea pariatur dolor.

      Ex irure et commodo ex Lorem nulla pariatur enim dolor voluptate veniam dolore occaecat ad. Est et do exercitation minim laboris. Elit anim dolor mollit dolor nostrud est quis aliqua nostrud aliquip do dolore adipisicing. Magna incididunt esse id non velit consequat irure velit dolor duis aliqua. Magna minim labore reprehenderit eiusmod consectetur amet nisi enim reprehenderit tempor. Id reprehenderit pariatur nostrud pariatur nostrud laboris. Ad ipsum culpa ex cillum.

      Duis ea ut minim cillum duis eiusmod nisi incididunt esse irure id occaecat. Nulla laboris et pariatur ut sit reprehenderit. Quis pariatur mollit aute incididunt esse qui consectetur commodo sunt minim aliquip excepteur cillum. Minim voluptate occaecat Lorem incididunt. Consequat officia adipisicing id pariatur duis voluptate id. Consequat cupidatat velit in Lorem enim reprehenderit pariatur eiusmod excepteur cillum non mollit est.

      Reprehenderit amet ut laboris do duis Lorem et nulla sunt voluptate. Eiusmod commodo aliquip exercitation magna do. Enim voluptate dolor consequat minim incididunt qui culpa.
      Occaecat aute tempor nostrud non. Commodo reprehenderit occaecat nulla exercitation aute aute eiusmod deserunt eiusmod adipisicing in. Deserunt esse eu nostrud occaecat ea elit deserunt nostrud. Cupidatat reprehenderit velit pariatur ad qui enim aliquip ipsum ut ex aliquip pariatur. Aute amet nulla ipsum consectetur pariatur ad elit ea qui labore. Laboris officia ullamco exercitation eu reprehenderit nisi laborum cillum in fugiat mollit duis nostrud nostrud.Et culpa magna amet labore exercitation ea minim. Quis cupidatat in in dolore. Reprehenderit mollit deserunt occaecat in eu ad veniam enim officia consequat aliquip reprehenderit eu.
      Ipsum ipsum sunt anim in irure est ullamco nisi. Velit cupidatat voluptate pariatur commodo exercitation deserunt aliqua nostrud sunt. Lorem veniam dolor et consequat deserunt anim ullamco consequat qui dolor ex et officia sunt. Aute laborum officia ut aliqua sint duis pariatur fugiat incididunt. Elit qui esse pariatur eu ipsum. Et sit voluptate ullamco veniam. Aute cupidatat tempor ad in dolore reprehenderit mollit nulla exercitation ea pariatur dolor.

      Ex irure et commodo ex Lorem nulla pariatur enim dolor voluptate veniam dolore occaecat ad. Est et do exercitation minim laboris. Elit anim dolor mollit dolor nostrud est quis aliqua nostrud aliquip do dolore adipisicing. Magna incididunt esse id non velit consequat irure velit dolor duis aliqua. Magna minim labore reprehenderit eiusmod consectetur amet nisi enim reprehenderit tempor. Id reprehenderit pariatur nostrud pariatur nostrud laboris. Ad ipsum culpa ex cillum.

      Duis ea ut minim cillum duis eiusmod nisi incididunt esse irure id occaecat. Nulla laboris et pariatur ut sit reprehenderit. Quis pariatur mollit aute incididunt esse qui consectetur commodo sunt minim aliquip excepteur cillum. Minim voluptate occaecat Lorem incididunt. Consequat officia adipisicing id pariatur duis voluptate id. Consequat cupidatat velit in Lorem enim reprehenderit pariatur eiusmod excepteur cillum non mollit est.

      At vero eos et accusamus et iusto odio dignissimos ducimus qui blanditiis praesentium voluptatum deleniti atque corrupti quos dolores et quas molestias excepturi sint occaecati cupiditate non provident, similique sunt in culpa qui officia deserunt mollitia animi, id est laborum et dolorum fuga. Et harum quidem rerum facilis est et expedita distinctio. Nam libero tempore, cum soluta nobis est eligendi optio cumque nihil impedit quo minus id quod maxime placeat facere possimus, omnis voluptas assumenda est, omnis dolor repellendus. Temporibus autem quibusdam et aut officiis debitis aut rerum necessitatibus saepe eveniet ut et voluptates repudiandae sint et molestiae non recusandae. Itaque earum rerum hic tenetur a sapiente delectus, ut aut reiciendis voluptatibus maiores alias consequatur aut perferendis doloribus asperiores repellat.

      Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt. Neque porro quisquam est, qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit, sed quia non numquam eius modi tempora incidunt ut labore et dolore magnam aliquam quaerat voluptatem. Ut enim ad minima veniam, quis nostrum exercitationem ullam corporis suscipit laboriosam, nisi ut aliquid ex ea commodi consequatur? Quis autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?

      Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur facilisis pharetra congue. Nulla volutpat, ipsum quis sodales dictum, est quam semper orci, quis egestas elit nulla at orci. Phasellus at lacinia enim. Sed et risus sed magna tempor vulputate ac ut tellus. Praesent pulvinar viverra erat in placerat. In leo metus, efficitur aliquet aliquam at, dignissim sit amet neque. Nulla ullamcorper rutrum malesuada. Cras vel dolor sapien. Etiam posuere, dolor non dignissim imperdiet, mi metus suscipit urna, eu vehicula dui ligula quis ipsum. Proin blandit aliquam sem sed ornare. Nulla at vulputate velit, et tristique felis. Nam accumsan sem nunc, quis tempus neque posuere vel. Lorem ipsum dolor sit amet, consectetur adipiscing elit.

Nullam urna est, egestas et nisi sed, sagittis auctor ante. Donec mattis, felis a congue blandit, libero ligula viverra est, in sodales erat sem sed tortor. Sed dolor ante, gravida quis dapibus non, interdum ac enim. Sed nec hendrerit urna. In mattis consectetur risus eu lacinia. Duis lacus risus, consectetur a nibh non, pharetra consequat tellus. Fusce cursus, diam in rutrum auctor, lectus arcu semper lorem, in blandit sapien libero ac ex. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Etiam tempus nisl vitae blandit venenatis. Nulla facilisi. Quisque urna orci, dapibus non elit in, mattis blandit nunc. Aliquam pharetra ligula vitae quam vulputate, et molestie est hendrerit. Vivamus a pellentesque libero, id congue velit.

Curabitur lobortis viverra ligula a faucibus. In ultricies in mi a tempus. Aenean ultrices libero vitae quam maximus tempus. Praesent ac nisl eget dolor iaculis dignissim. Pellentesque tempor nunc eget elementum vulputate. Nullam et nibh nec arcu pulvinar congue. Quisque vehicula ligula magna. Ut quis enim consequat, convallis est eu, sagittis tortor. Donec vel nisi elit. Vestibulum ut dignissim dui. Integer sit amet orci ut tellus egestas accumsan. Mauris non interdum est, in tempor justo. Donec sapien diam, ultricies a vulputate at, viverra ut felis. Donec nec luctus mauris. In sodales hendrerit imperdiet. Duis ac nisi pulvinar, molestie nibh quis, accumsan tortor.

Sed efficitur neque nunc. Cras a tristique justo, ullamcorper luctus justo. In hac habitasse platea dictumst. Morbi non luctus odio, non faucibus enim. Nunc in commodo erat. Proin tristique sem quis dapibus facilisis. Suspendisse ac accumsan ante. Morbi quis commodo massa, ut molestie est.

Donec id turpis metus. Nullam posuere pretium gravida. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Praesent volutpat, justo ut viverra egestas, massa nibh placerat eros, a euismod turpis justo vitae ipsum. In at tortor velit. Etiam congue erat sit amet molestie convallis. Nullam pulvinar massa non metus molestie ultricies. Phasellus maximus magna ac sapien vehicula, at sollicitudin neque consectetur. Vivamus ligula arcu, cursus nec nisi ut, cursus ullamcorper justo. Aliquam arcu leo, finibus sit amet tristique eu, tempor ut nisi. Nulla et justo commodo, scelerisque enim et, consectetur libero. Nam cursus commodo quam eget aliquam. Sed mattis finibus ligula a pulvinar. Sed feugiat purus sem, eget mollis dui ullamcorper eu. Sed mollis congue est, non sodales dolor hendrerit fermentum. Etiam a libero ac velit commodo consequat non id urna.

Sed eu scelerisque elit. Cras luctus metus et eros aliquet maximus. Nam laoreet ligula vel nulla eleifend porta. Sed sapien felis, tincidunt ut ullamcorper ac, finibus non magna. Suspendisse potenti. Sed non dolor egestas arcu lobortis suscipit consectetur consectetur orci. Fusce mollis euismod dignissim. Sed pharetra ante quis dui vulputate vulputate et nec lacus.

Aenean sit amet venenatis elit, at ultricies neque. Ut et sodales sapien, a aliquam felis. Aenean ultricies, ex quis vestibulum posuere, ipsum tortor venenatis massa, dictum aliquam ipsum dui non massa. Pellentesque quis tellus sagittis, dictum sem id, ultricies purus. Nulla nunc diam, blandit faucibus vulputate vitae, scelerisque at urna. Sed at lobortis leo. Quisque vel velit non purus viverra condimentum sit amet eu libero. Nam non felis est. Ut consectetur vehicula diam sed tristique.

Vivamus eget nulla vitae arcu mollis venenatis eget commodo tortor. Ut rutrum velit massa, ut efficitur dui rutrum in. Vivamus tempor elit in odio ultrices tristique in id erat. Morbi egestas nec turpis dignissim fermentum. Nulla facilisi. Aenean sit amet euismod lacus, nec ultrices eros. Fusce tincidunt risus consectetur, sagittis felis iaculis, iaculis nunc. Proin tincidunt, elit et pharetra aliquet, nulla urna molestie tortor, et gravida velit lorem non magna. Nullam vehicula a odio vehicula posuere. Donec molestie purus eget nulla ullamcorper tempor. In hac habitasse platea dictumst. Nullam pretium congue felis vel bibendum.

Curabitur faucibus, orci ut tristique dapibus, ex mi tincidunt justo, ut lacinia erat nibh et nunc. Aliquam egestas tincidunt tristique. Etiam hendrerit mi nisi, at facilisis risus fringilla et. Donec dictum justo tellus, scelerisque sagittis orci egestas at. Mauris in turpis at dui ullamcorper hendrerit vitae vel justo. Maecenas lobortis erat nec sem suscipit ullamcorper. Sed tellus neque, laoreet vel lectus a, tincidunt rutrum purus.

Vivamus sodales vitae lorem in maximus. Cras condimentum, augue non tempor commodo, risus lorem auctor nulla, non pellentesque felis metus ac ante. Etiam non sapien et tellus semper egestas. Donec in dolor eleifend ex tincidunt blandit nec eu justo. Nam ut turpis urna. Sed venenatis rutrum tellus et euismod. Suspendisse potenti. Fusce bibendum massa quis pretium convallis. Ut commodo mi non lectus faucibus, at imperdiet mi feugiat. Nam eget egestas odio. Donec rhoncus ante sit amet orci volutpat condimentum. Praesent pulvinar magna id turpis interdum, sit amet lobortis ex convallis. Vivamus in accumsan augue.

Curabitur egestas dolor quis imperdiet pharetra. Vestibulum a bibendum neque. Proin sit amet mauris pellentesque, dignissim neque in, auctor sem. Nam rutrum mi a quam condimentum, id dignissim ligula iaculis. Etiam enim libero, vehicula et scelerisque nec, rutrum non lacus. In eleifend diam mi, sed viverra diam varius bibendum. Duis sollicitudin condimentum varius. Fusce tempus tortor quis urna accumsan, eget lacinia leo tincidunt. Sed eget viverra libero. Cras a neque id quam vulputate bibendum ac at augue. Nullam dictum ex scelerisque nisl iaculis volutpat. Aliquam vitae augue quis velit porta tempor pulvinar et purus.
</div>
    </ScrollContainer>

    <ScrollContainer style={{height: '30vh'}} onScrollStart={() => console.log('start')} onScrollStop={() => console.log('stop')}>
      <button>Duis aliqua et esse et velit elit.</button>
      <p>
        Id laborum excepteur consequat duis duis exercitation incididunt aute sunt incididunt quis consectetur nulla tempor. Ipsum dolore ipsum anim ea velit cillum nostrud nisi eu et ad irure ut elit. Est deserunt do exercitation ea commodo mollit ut non exercitation anim commodo excepteur. Commodo
        enim ea culpa labore id nisi eu voluptate ad. Tempor labore Lorem qui Lorem. Consectetur in eu ut esse exercitation qui est ea magna reprehenderit magna excepteur.enim ea culpa labore id nisi eu voluptate ad. Tempor labore Lorem qui Lorem. Consectetur in eu ut esse exercitation qui est ea magna reprehenderit magna excepteur.
        enim ea culpa labore id nisi eu voluptate ad. Tempor labore Lorem qui Lorem. Consectetur in eu ut esse exercitation qui est ea magna reprehenderit magna excepteur.enim ea culpa labore id nisi eu voluptate ad. Tempor labore Lorem qui Lorem. Consectetur in eu ut esse exercitation qui est ea magna reprehenderite id nisi eu voluptate ad. Tempor labore Lorem qui Lorem. Consectetur in eu ut esse exercitation qui est ea magna reprehenderit magna excepteur.enim ea culpa labore id nisi eu voluptate ad. Tempor labore Lorem qui Lorem. Consectetur in eu ut esse exercitation qui est ea magna reprehenderit mag nisi eu voluptate ad. Tempor labore Lorem qui Lorem. Consectetur in eu ut esse exercitation qui est ea magna reprehenderit magna excepteur.enim ea culpa labore id nisi eu voluptate ad. Tempor labore Lorem qui Lorem. Consectetur in eu ut esse exercitation qui est ea magna reprehenderit magna excepteur.enim ea culpa labore id nisi eu voluptate ad. Tempor labore Lorem qui Lorem. Consectetur in eu ut esse exercitation qui est ea magna reprehenderit magna excepteur.enim ea culpa labore id nisi eu voluptate ad. Tempor labore Lorem qui Lorem. Consectetur in eu ut esse exercitation qui est ea magna reprehenderit magna excepteur.enim ea culpa labore id nisi eu voluptate ad. Tempor labore Lorem qui Lorem. Consectetur in eu ut esse exercitation qui est ea magna reprehenderit magna excepteur.enim ea culpa labore id nisi eu voluptate ad. Tempor labore Lorem qui Lorem. Consectetur in eu ut esse exercitation qui est ea magna reprehenderit magna excepteur.
      </p>
    </ScrollContainer>

    <button onClick={() => this.s.updateScrollbars() }>update scrollbars</button>

    <ScrollContainer autoHide={false} ref={(c) => this.s = c} style={{ height: 300, width: 300}} inlineBlock >
      <div style={{height: 411, width: 340, background: 'red', border: '1px solid blue'}}>
        <div>
          Counter - {this.state.counter} - <button onClick={this.plusOne}>+1</button>
        </div>

        <div> ScrollTop:
          <input type="text" defaultValue={this.state.scrollTop} onChange={this.onChangeScrollTop} />
          <button onClick={this.go}>Go</button>
        </div>

        <div>
          Send counter to list: <input type="checkbox" checked={this.state.sendCounter} onChange={this.toggleSendCounter} />
        </div>
        </div>
      </ScrollContainer>

      {/*

      <ScrollContainer style={{
        width: 200,
        height: 200,
        margin: 20,
        background: 'gray',
        border: '1px solid #ff6b11'
      }}>
        <div style={{
          background: 'blue',
          width: 1490,
          height: 1250,
        }}>
          <button onClick={() => console.log('click')}>ok</button>
          <input defaultValue="dasdas" style={{border: '1px solid black', display: 'inline-block', width: 250 }} /> <input defaultValue="test" style={{display: 'inline-block'}} />

          <div style={{border: '1px solid white', height: 500}} />
        </div>
      </ScrollContainer>
      */}
      </div>
  }
}

render(<App />, document.querySelector('#content'))
