'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _SIZES, _OTHER_SIZES, _MARGINS;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _autoBind = require('react-class/autoBind');

var _autoBind2 = _interopRequireDefault(_autoBind);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _shouldComponentUpdate2 = require('./shouldComponentUpdate');

var _shouldComponentUpdate3 = _interopRequireDefault(_shouldComponentUpdate2);

var _join = require('./join');

var _join2 = _interopRequireDefault(_join);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var HORIZONTAL = 'horizontal';
var VERTICAL = 'vertical';

var SIZES = (_SIZES = {}, _defineProperty(_SIZES, VERTICAL, 'height'), _defineProperty(_SIZES, HORIZONTAL, 'width'), _SIZES);
var OTHER_SIZES = (_OTHER_SIZES = {}, _defineProperty(_OTHER_SIZES, VERTICAL, 'width'), _defineProperty(_OTHER_SIZES, HORIZONTAL, 'height'), _OTHER_SIZES);

var MARGINS = (_MARGINS = {}, _defineProperty(_MARGINS, VERTICAL, 'right'), _defineProperty(_MARGINS, HORIZONTAL, 'bottom'), _MARGINS);

var STYLES = {
  vertical: {
    position: 'absolute',
    top: 0,
    bottom: 0,
    right: 0
  },
  horizontal: {
    position: 'absolute',
    left: 0,
    right: 0,
    bottom: 0
  }
};

var Scrollbar = function (_Component) {
  _inherits(Scrollbar, _Component);

  function Scrollbar(props) {
    _classCallCheck(this, Scrollbar);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Scrollbar).call(this, props));

    (0, _autoBind2.default)(_this);

    _this.state = {
      scrollPos: 0
    };
    return _this;
  }

  _createClass(Scrollbar, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return (0, _shouldComponentUpdate3.default)(this, nextProps, nextState);
    }
  }, {
    key: 'setVisible',
    value: function setVisible(visible) {
      this.setState({
        visible: visible
      });
    }
  }, {
    key: 'setScrollPos',
    value: function setScrollPos(scrollPos) {
      this.setState({
        scrollPos: scrollPos
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _thumbStyle;

      var props = this.props;
      var className = props.className;
      var style = props.style;
      var orientation = props.orientation;
      var vertical = props.vertical;
      var horizontal = props.horizontal;
      var visible = props.visible;


      if (orientation) {
        vertical = orientation == VERTICAL;
        horizontal = !vertical;
      }

      orientation = horizontal ? HORIZONTAL : VERTICAL;

      var sizeName = SIZES[orientation];
      var otherSizeName = OTHER_SIZES[orientation];

      if (this.state.visible !== undefined) {
        visible = this.state.visible;
      }

      var hiding = !visible && this.prevVisible;
      var showing = visible && !this.prevVisible;

      className = (0, _join2.default)(className, 'react-scroll-container__scrollbar', 'react-scroll-container__scrollbar--orientation-' + orientation, !visible && 'react-scroll-container__scrollbar--hidden', hiding && 'react-scroll-container__scrollbar--hiding', showing && 'react-scroll-container__scrollbar--showing');

      style = (0, _objectAssign2.default)({}, style, STYLES[orientation]);

      if (showing && this.props.showTransitionDuration) {
        style.transitionDuration = this.props.showTransitionDuration;
      }
      if (hiding && this.props.hideTransitionDuration) {
        style.transitionDuration = this.props.hideTransitionDuration;
      }

      this.prevVisible = visible;

      var divProps = (0, _objectAssign2.default)({}, props);

      delete divProps.clientSize;
      delete divProps.emptyScrollOffset;
      delete divProps.hideTransitionDuration;
      delete divProps.horizontal;
      delete divProps.oppositeVisible;
      delete divProps.orientation;
      delete divProps.nativeScrollbarWidth;
      delete divProps.scrollSize;
      delete divProps.scrollThumbMargin;
      delete divProps.scrollThumbRadius;
      delete divProps.scrollThumbStartEndRespectMargin;
      delete divProps.scrollThumbWidth;
      delete divProps.showTransitionDuration;
      delete divProps.size;
      delete divProps.trackSize;
      delete divProps.vertical;
      delete divProps.visible;

      var thumbSize = this.getThumbSize();

      var transform = this.getThumbTransform(orientation, thumbSize);

      var thumbStyle = (_thumbStyle = {}, _defineProperty(_thumbStyle, sizeName, thumbSize), _defineProperty(_thumbStyle, otherSizeName, this.props.scrollThumbWidth), _defineProperty(_thumbStyle, 'transform', transform), _defineProperty(_thumbStyle, 'borderRadius', this.props.scrollThumbRadius || this.props.scrollThumbWidth), _thumbStyle);

      if (this.props.scrollThumbMargin) {
        thumbStyle[MARGINS[orientation]] = this.props.scrollThumbMargin;
      }

      var thumbClassName = 'react-scroll-container__thumb react-scroll-container__thumb--orientation-' + orientation;

      return _react2.default.createElement(
        'div',
        _extends({}, divProps, {
          style: style,
          className: className,
          'data-orientation': orientation
        }),
        _react2.default.createElement('div', { style: thumbStyle, className: thumbClassName })
      );
    }
  }, {
    key: 'getThumbTransform',
    value: function getThumbTransform(orientation, thumbSize) {
      var scrollPos = this.state.scrollPos;

      var _props = this.props;
      var clientSize = _props.clientSize;
      var scrollThumbStartEndRespectMargin = _props.scrollThumbStartEndRespectMargin;
      var scrollThumbMargin = _props.scrollThumbMargin;
      var nativeScrollbarWidth = _props.nativeScrollbarWidth;
      var emptyScrollOffset = _props.emptyScrollOffset;
      var _props2 = this.props;
      var trackSize = _props2.trackSize;
      var scrollSize = _props2.scrollSize;


      if (!nativeScrollbarWidth) {
        scrollSize -= emptyScrollOffset;
      }
      trackSize -= scrollThumbMargin * (scrollThumbStartEndRespectMargin ? 2 : 1);

      scrollPos = scrollPos / (scrollSize - clientSize) * (trackSize - thumbSize);

      if (scrollThumbStartEndRespectMargin) {
        scrollPos += scrollThumbMargin;
      }

      scrollPos = Math.floor(scrollPos);

      if (orientation == VERTICAL) {
        return 'translate3d(0px, ' + scrollPos + 'px, 0px)';
      }

      return 'translate3d(' + scrollPos + 'px, 0px, 0px)';
    }
  }, {
    key: 'getThumbSize',
    value: function getThumbSize() {
      var _props3 = this.props;
      var scrollSize = _props3.scrollSize;
      var trackSize = _props3.trackSize;
      var clientSize = _props3.clientSize;

      /*
       * thumbSize   clientSize
       * --------- = --------
       * trackSize   scrollSize
       */

      return scrollSize ? trackSize * clientSize / scrollSize : 0;
    }
  }]);

  return Scrollbar;
}(_react.Component);

exports.default = Scrollbar;


Scrollbar.defaultProps = {
  scrollThumbMargin: 2
};

Scrollbar.propTypes = {
  clientSize: _react.PropTypes.number,
  emptyScrollOffset: _react.PropTypes.number,
  horizontal: _react.PropTypes.bool,
  orientation: _react.PropTypes.oneOf([VERTICAL, HORIZONTAL]),
  oppositeVisible: _react.PropTypes.bool, // true when the other scrollbar is also visible
  nativeScrollbarWidth: _react.PropTypes.number.isRequired,
  scrollSize: _react.PropTypes.number,
  scrollThumbMargin: _react.PropTypes.number.isRequired,
  scrollThumbRadius: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
  scrollThumbStartEndRespectMargin: _react.PropTypes.bool,
  scrollThumbWidth: _react.PropTypes.number,
  trackSize: _react.PropTypes.number,
  vertical: _react.PropTypes.bool,
  visible: _react.PropTypes.bool
};