'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _autoBind = require('react-class/autoBind');

var _autoBind2 = _interopRequireDefault(_autoBind);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _reactNotifyResize = require('react-notify-resize');

var _lodash = require('lodash.debounce');

var _lodash2 = _interopRequireDefault(_lodash);

var _Scrollbar = require('./Scrollbar');

var _Scrollbar2 = _interopRequireDefault(_Scrollbar);

var _getScrollbarWidth = require('./getScrollbarWidth');

var _getScrollbarWidth2 = _interopRequireDefault(_getScrollbarWidth);

var _shouldComponentUpdate2 = require('./shouldComponentUpdate');

var _shouldComponentUpdate3 = _interopRequireDefault(_shouldComponentUpdate2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EMPTY_SCROLL_OFFSET = 100; //getScrollbarWidth()
var EMPTY_SCROLL_VIEW_CHILD_STYLE = {
  paddingBottom: EMPTY_SCROLL_OFFSET
};
var WRAPPER_STYLE = {
  overflow: 'hidden',
  flex: 1,
  position: 'relative',
  display: 'flex'
};

var SIZES = {
  vertical: 'height',
  horizontal: 'width'
};

var cleanup = void 0;

var ScrollContainer = function (_Component) {
  _inherits(ScrollContainer, _Component);

  function ScrollContainer(props) {
    _classCallCheck(this, ScrollContainer);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ScrollContainer).call(this, props));

    (0, _autoBind2.default)(_this, { scrollTop: 1, scrollLeft: 1 });

    _this.state = {
      scrollbars: {
        horizontal: false,
        vertical: false
      }
    };

    _this.onStop = (0, _lodash2.default)(_this.onStop, props.scrollStopDelay, { leading: false });

    _this.nativeScrollbarWidth = (0, _getScrollbarWidth2.default)();

    _this.scroll = {
      scrollTop: 0,
      scrollLeft: 0
    };

    _this.trackSize = {};
    _this.clientSize = {};
    _this.scrollSize = {};
    _this.scrollbars = {};

    _this.scrollbarRef = {
      vertical: function vertical(c) {
        _this.scrollbars.vertical = c;
      },
      horizontal: function horizontal(c) {
        _this.scrollbars.horizontal = c;
      }
    };

    _this.refThis = function (c) {
      _this.domNode = c;
    };

    _this.refWrapper = function (c) {
      _this.wrapperNode = c;
    };
    _this.refScroller = function (c) {
      _this.scrollerNode = c;
    };
    return _this;
  }

  _createClass(ScrollContainer, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return (0, _shouldComponentUpdate3.default)(this, nextProps, nextState);
    }
  }, {
    key: 'ensureNonStaticStyle',
    value: function ensureNonStaticStyle(style, domNode) {
      if (!this.props.forceNonStaticPosition) {
        return style;
      }
      style = style || {};
      var _style = style;
      var position = _style.position;

      var nonStatic = position == 'relative' || position == 'absolute';

      if (nonStatic) {
        return style;
      }

      if (domNode) {
        position = global.getComputedStyle(domNode).position;
        nonStatic = position == 'relative' || position == 'absolute';

        if (!nonStatic) {
          return (0, _objectAssign2.default)({}, style, { position: 'relative' });
        }
      }

      return (0, _objectAssign2.default)({}, style, { position: 'relative' });
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;
      var renderScroller = props.renderScroller;
      var renderView = props.renderView;
      var Factory = props.factory;
      var inlineBlock = props.inlineBlock;
      var _props$className = props.className;
      var className = _props$className === undefined ? '' : _props$className;
      var style = props.style;
      var children = props.children;


      style = (0, _objectAssign2.default)({
        overflow: 'hidden',
        display: inlineBlock ? 'inline-flex' : 'flex',
        flexFlow: 'column'
      }, this.ensureNonStaticStyle(style, this.domNode));

      var factoryProps = cleanup((0, _objectAssign2.default)({}, props));

      className += inlineBlock ? ' react-scroll-container--inline-block' : ' react-scroll-container--block';

      className += ' react-scroll-container';

      var nativeScrollbarWidth = this.nativeScrollbarWidth;
      var wrapperStyle = WRAPPER_STYLE;

      var scrollerStyle = {
        overflow: 'scroll',
        position: 'relative',
        boxSizing: 'border-box',
        flex: 1
      };

      if (!nativeScrollbarWidth) {
        (0, _objectAssign2.default)(scrollerStyle, {
          display: 'flex',
          marginRight: -EMPTY_SCROLL_OFFSET,
          marginBottom: -EMPTY_SCROLL_OFFSET
        });
      } else {
        (0, _objectAssign2.default)(scrollerStyle, {
          margin: -nativeScrollbarWidth,
          padding: nativeScrollbarWidth + 'px 0px 0px ' + nativeScrollbarWidth + 'px'
        });
      }

      var viewClassName = 'react-scroll-container__view ' + (!nativeScrollbarWidth ? 'react-scroll-container__view--zero-width-scrollbar' : '');
      var viewStyle = { position: 'relative', boxSizing: 'border-box' };
      var viewChildren = children;

      if (!nativeScrollbarWidth) {
        viewStyle = (0, _objectAssign2.default)(viewStyle, {
          flex: '1 0 100%',
          paddingRight: EMPTY_SCROLL_OFFSET
        });
        viewChildren = _react2.default.createElement(
          'div',
          { style: EMPTY_SCROLL_VIEW_CHILD_STYLE },
          children
        );
      }

      var viewProps = {
        className: viewClassName,
        style: viewStyle,
        children: [viewChildren, _react2.default.createElement(_reactNotifyResize.NotifyResize, { onResize: this.onViewResize, notifyOnMount: true })]
      };

      var view = renderView ? renderView(viewProps) : _react2.default.createElement('div', viewProps);

      var scrollerProps = {
        className: 'react-scroll-container__scroller',
        style: scrollerStyle,
        ref: this.refScroller,
        onScroll: this.onScroll,
        children: [view, _react2.default.createElement(_reactNotifyResize.NotifyResize, { onResize: this.onResize, notifyOnMount: true })]
      };

      var scroller = renderScroller ? renderScroller(scrollerProps) : _react2.default.createElement('div', scrollerProps);

      children = [_react2.default.createElement('div', {
        className: 'react-scroll-container__wrapper',
        ref: this.refWrapper,
        style: wrapperStyle,
        children: scroller
      })].concat(_toConsumableArray(this.renderScrollbars()));

      return Factory ? _react2.default.createElement(Factory, _extends({}, factoryProps, {
        ref: this.refThis,
        style: style,
        className: className,
        children: children
      })) : (0, _react.createElement)(props.tagName, (0, _objectAssign2.default)(factoryProps, {
        ref: this.refThis,
        style: style,
        className: className,
        children: children
      }));
    }
  }, {
    key: 'onViewResize',
    value: function onViewResize(size) {
      this.sync();

      if (this.props.onViewResize) {
        this.props.onViewResize(size, this);
      }
    }
  }, {
    key: 'onResize',
    value: function onResize(size) {
      this.sync();

      if (this.props.onResize) {
        this.props.onResize(size, this);
      }
    }
  }, {
    key: 'renderScrollbars',
    value: function renderScrollbars() {
      return [this.state.scrollbars.vertical && this.renderScrollbar('vertical'), this.state.scrollbars.horizontal && this.renderScrollbar('horizontal')];
    }
  }, {
    key: 'renderScrollbar',
    value: function renderScrollbar(orientation) {
      var sizeName = SIZES[orientation];
      var nativeScrollbarWidth = this.nativeScrollbarWidth;

      var scrollbarProps = {
        ref: this.scrollbarRef[orientation],
        emptyScrollOffset: EMPTY_SCROLL_OFFSET,
        nativeScrollbarWidth: nativeScrollbarWidth,
        orientation: orientation,
        visible: !this.props.autoHide,

        trackSize: this.trackSize[sizeName],
        scrollSize: this.scrollSize[sizeName],
        clientSize: this.clientSize[sizeName],

        scrollThumbMargin: this.props.scrollThumbMargin,
        scrollThumbRadius: this.props.scrollThumbRadius,
        scrollThumbStartEndRespectMargin: this.props.scrollThumbStartEndRespectMargin,
        scrollThumbWidth: this.props.scrollThumbWidth,
        hideTransitionDuration: this.props.hideTransitionDuration,
        showTransitionDuration: this.props.showTransitionDuration
      };

      return _react2.default.createElement(_Scrollbar2.default, scrollbarProps);
    }
  }, {
    key: 'getScrollerNode',
    value: function getScrollerNode() {
      this.scrollerNode = this.scrollerNode || (0, _reactDom.findDOMNode)(this).firstChild.firstChild;
      return this.scrollerNode;
    }
  }, {
    key: 'getScrollerChild',
    value: function getScrollerChild() {
      this.scrollerChild = this.scrollerChild || this.getScrollerNode().firstChild;
      return this.scrollerChild;
    }
  }, {
    key: 'getTrackSize',
    value: function getTrackSize() {
      var node = (0, _reactDom.findDOMNode)(this);
      return {
        width: node.clientWidth,
        height: node.clientHeight
      };
    }
  }, {
    key: 'getScrollSize',
    value: function getScrollSize() {
      var node = this.getScrollerChild();
      return {
        width: node.scrollWidth,
        height: node.scrollHeight
      };
    }
  }, {
    key: 'getClientSize',
    value: function getClientSize() {
      var node = (0, _reactDom.findDOMNode)(this).firstChild;

      return {
        width: node.clientWidth,
        height: node.clientHeight
      };
    }
  }, {
    key: 'getScrollbars',
    value: function getScrollbars() {
      this.trackSize = this.getTrackSize();
      var scrollSize = this.scrollSize = this.getScrollSize();
      this.clientSize = this.getClientSize();

      var scrollerNode = this.getScrollerNode();

      return {
        vertical: scrollSize.height > scrollerNode.clientHeight,
        horizontal: scrollSize.width > scrollerNode.clientWidth
      };
    }
  }, {
    key: 'sync',
    value: function sync() {
      this.setState({
        scrollbars: this.getScrollbars()
      });
    }
  }, {
    key: 'onScroll',
    value: function onScroll(event) {
      if (event.target != this.scrollerNode) {
        return;
      }

      var _props = this.props;
      var onScrollStart = _props.onScrollStart;
      var onScrollStop = _props.onScrollStop;
      var autoHide = _props.autoHide;

      var startStop = !!(onScrollStart || onScrollStop || autoHide);

      var _event$target = event.target;
      var scrollTop = _event$target.scrollTop;
      var scrollLeft = _event$target.scrollLeft;


      var scrollPos = { scrollTop: scrollTop, scrollLeft: scrollLeft };
      var prevScrollPos = this.scroll;

      var prevScrollTop = prevScrollPos.scrollTop;
      var prevScrollLeft = prevScrollPos.scrollLeft;


      if (startStop) {
        if (!this.scrollStarted) {
          if (onScrollStart) {
            onScrollStart(scrollPos, prevScrollPos);
          }
        }
      }

      var scrollVertical = false;
      var scrollHorizontal = false;

      if (this.props.onContainerScroll) {
        this.props.onContainerScroll(scrollPos, prevScrollPos);
      }

      if (this.scrollbars.vertical && scrollTop != prevScrollTop) {
        scrollVertical = true;
        this.scrollbars.vertical.setScrollPos(scrollTop);
        if (this.props.onContainerScrollTop) {
          this.props.onContainerScrollTop(scrollTop, prevScrollTop);
        }
      }
      if (this.scrollbars.horizontal && scrollLeft != prevScrollLeft) {
        scrollHorizontal = true;
        this.scrollbars.horizontal.setScrollPos(scrollLeft);
        if (this.props.onContainerScrollLeft) {
          this.props.onContainerScrollLeft(scrollLeft, prevScrollLeft);
        }
      }

      if (startStop) {
        if (!this.scrollStarted || this.scrollStarted.vertical != scrollVertical || this.scrollStarted.horizontal != scrollHorizontal) {
          this.lazyShowScrollbars();

          this.scrollStarted = {
            horizontal: scrollHorizontal,
            vertical: scrollVertical
          };
        }

        this.onStop(scrollPos, prevScrollPos);
      }

      this.scroll = scrollPos;
    }
  }, {
    key: 'lazyShowScrollbars',
    value: function lazyShowScrollbars() {
      if (this.props.autoHide) {
        setTimeout(this.showScrollbars, this.props.showDelay);
      }
    }
  }, {
    key: 'onStop',
    value: function onStop(scrollPos, prevScrollPos) {
      this.scrollStarted = false;

      if (this.props.onScrollStop) {
        this.props.onScrollStop(scrollPos, prevScrollPos);
      }

      setTimeout(this.hideScrollbars, this.props.hideDelay);
    }
  }, {
    key: 'showScrollbars',
    value: function showScrollbars() {
      if (this.props.autoHide && this.scrollStarted) {
        var _scrollbars = this.scrollbars;
        var horizontal = _scrollbars.horizontal;
        var vertical = _scrollbars.vertical;
        var _scrollStarted = this.scrollStarted;
        var scrollHorizontal = _scrollStarted.horizontal;
        var scrollVertical = _scrollStarted.vertical;


        if (horizontal && scrollHorizontal) {
          horizontal.setVisible(true);
        }
        if (vertical && scrollVertical) {
          vertical.setVisible(true);
        }
      }
    }
  }, {
    key: 'hideScrollbars',
    value: function hideScrollbars() {
      if (this.props.autoHide && !this.scrollStarted) {
        var _scrollbars2 = this.scrollbars;
        var horizontal = _scrollbars2.horizontal;
        var vertical = _scrollbars2.vertical;


        if (horizontal) {
          horizontal.setVisible(false);
        }
        if (vertical) {
          vertical.setVisible(false);
        }
      }
    }
  }, {
    key: 'scrollTop',
    set: function set(value) {
      this.getScrollerNode().scrollTop = value;
    },
    get: function get() {
      return this.scroll.scrollTop;
    }
  }, {
    key: 'scrollLeft',
    set: function set(value) {
      this.getScrollerNode().scrollLeft = value;
    },
    get: function get() {
      return this.scroll.scrollLeft;
    }
  }]);

  return ScrollContainer;
}(_react.Component);

exports.default = ScrollContainer;


ScrollContainer.defaultProps = {
  autoHide: true,
  forceNonStaticPosition: false,
  hideDelay: 300,
  hideTransitionDuration: '300ms',
  inlineBlock: false,
  scrollStopDelay: 100,

  scrollThumbStartEndRespectMargin: false,
  scrollThumbWidth: 6,
  showDelay: 100,
  showTransitionDuration: '100ms',
  tagName: 'div'
};

ScrollContainer.propTypes = {
  autoHide: _react.PropTypes.bool,
  inlineBlock: _react.PropTypes.bool,

  factory: _react.PropTypes.func,
  forceNonStaticPosition: _react.PropTypes.bool,
  hideDelay: _react.PropTypes.number,

  onContainerScroll: _react.PropTypes.func,
  onContainerScrollLeft: _react.PropTypes.func,
  onContainerScrollTop: _react.PropTypes.func,

  onResize: _react.PropTypes.func,
  onScrollStart: _react.PropTypes.func,
  onScrollStop: _react.PropTypes.func,
  onViewResize: _react.PropTypes.func,

  renderScroller: _react.PropTypes.func,
  renderView: _react.PropTypes.func,
  scrollStopDelay: _react.PropTypes.number,
  scrollThumbMargin: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
  scrollThumbRadius: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
  scrollThumbStartEndRespectMargin: _react.PropTypes.bool,
  scrollThumbWidth: _react.PropTypes.number,
  showDelay: _react.PropTypes.number,
  tagName: _react.PropTypes.string
};

cleanup = function cleanup(props) {
  delete props.autoHide;
  delete props.factory;
  delete props.forceNonStaticPosition;
  delete props.hideDelay;
  delete props.hideTransitionDuration;
  delete props.inlineBlock;
  delete props.onResize;
  delete props.onContainerScroll;
  delete props.onContainerScrollLeft;
  delete props.onContainerScrollTop;
  delete props.onScrollStart;
  delete props.onScrollStop;
  delete props.onViewResize;
  delete props.renderScroller;
  delete props.renderView;
  delete props.scrollStopDelay;
  delete props.scrollThumbMargin;
  delete props.scrollThumbStartEndRespectMargin;
  delete props.scrollThumbWidth;
  delete props.showDelay;
  delete props.showTransitionDuration;
  delete props.tagName;

  return props;
};